PROGRAM disassembler;

  (* Disassembler fr die Dekodierung von MCS_48-Code *)
  (* Angelehnt an ein Programm aus der ct-2/86 Seite 69 *)

CONST
  anzahl_befehle = 117;


  source : ARRAY (. 0..anzahl_befehle .) OF STRING (. 20 .) =
  ('000,NOP',
    '002,OUTL   BUS.A',
    '003,ADD    A.#,1',
    '004,JMP    0,1',
    '005,EN     I',
    '007,DEC    A',
    '008,INS    A.BUS',
    '009,IN     A.P,4',
    '012,MOVD   A.P,4',
    '016,INC    @R,3',
    '018,JBO     ,1',
    '019,ADDC   A.#,1',
    '020,CALL   0,1',
    '021,DIS    I',
    '022,JTF    ,1',
    '023,INC    A',
    '024,INC    R,2',
    '032,XCH    A.@R,3',
    '035,MOV    A.#,1',
    '036,JMP    1,1',
    '037,EN     TCNTI',
    '038,JNTO   ,1',
    '039,CLR    A',
    '040,XCH    A.R,2',
    '048,XCHD   A.@R,3',
    '050,JB1    ,1',
    '052,CALL   1,1',
    '053,DIS    TCNTI',
    '054,JT0    ,1',
    '055,CPL    A',
    '057,OUTL   P,4,.A',
    '060,MOVD   P,4,.A',
    '064,ORL    A.@R,3',
    '066,MOV    A.T',
    '067,ORL    A.#,1',
    '068,JMP    2,1',
    '069,STRT   CNT',
    '070,JNT1   ,1',
    '071,SWAP   A',
    '072,ORL    A.R,2',
    '080,ANL    A.@R,3',
    '082,JB2    ,1',
    '083,ANL    A.#,1',
    '084,CALL   2,1',
    '085,STRT   T',
    '086,JT1    ,1',
    '087,DA     A',
    '088,ANL    A.R,2',
    '096,ADD    A.@R,3',
    '098,MOV    T.A',
    '100,JMP    3,1',
    '101,STOP   TCNT',
    '103,RRC    A',
    '104,ADD    A.R,2',
    '112,ADDC   A.@R,3',
    '114,JB3    ,1',
    '116,CALL   3,1',
    '117,ENTO   CLK',
    '118,JF1    ,1',
    '119,RR     A',
    '120,ADDC   A.R,2',
    '128,MOVX   A.@R,3',
    '131,RET',
    '132,JMP    4,1',
    '133,CLR    F0',
    '134,JNI    ,1',
    '136,ORL    BUS.#,1',
    '137,ORL    P,4,.#,1',
    '140,ORLD   P,4,.A',
    '144,MOVX   @R,3,.A',
    '146,JB4    ,1',
    '147,RETR',
    '148,CALL   4,1',
    '149,CPL    F0',
    '150,JNZ    ,1',
    '151,CLR    C',
    '152,ANL    BUS.#,1',
    '153,ANL    P,4,.#,1',
    '156,ANLD   P,4,.A',
    '160,MOV    @R,3,.A',
    '163,MOVP   A.@A',
    '164,JMP    5,1',
    '165,CLR    F1',
    '167,CPL    C',
    '168,MOV    R,2,.A',
    '176,MOV    @R,3,.#,1',
    '178,JB5    ,1',
    '179,JMPP   @A',
    '180,CALL   5,1',
    '181,CPL    F1',
    '182,JF0    ,1',
    '184,MOV    R,2,.#,1',
    '196,JMP    6,1',
    '197,SEL    RB0',
    '198,JZ     ,1',
    '199,MOV    A,PSW',
    '200,DEC    R,2',
    '208,XRL    A.@R,3',
    '210,JB6    ,1',
    '211,XRL    A.#,1',
    '212,CALL   6,1',
    '213,SEL    RB1',
    '215,MOV    PSW.A',
    '216,XRL    A.R,2',
    '227,MOV3   A.@A',
    '228,JMP    7,1',
    '229,SEL    MB0',
    '230,JNC    ,1',
    '231,RL     A',
    '232,DJNZ   R,2,.,1',
    '240,MOV    A.@R,3',
    '242,JB7    ,1',
    '244,CALL   7,1',
    '245,SEL    MB1',
    '246,JC     ,1',
    '247,RLC    A',
    '248,MOV    A.R,2',
    '999, ENDE');
TYPE
  t_dat_name = STRING (. 10 .);
  AAA = STRING (. 40 .);



VAR

  I, J, K, OP, ad_zaehler : INTEGER;

  name : STRING (. 13 .);
  datei : TEXT;
  opcode : ARRAY (. 0..255 .) OF STRING (. 20 .);
  a_string : STRING (. 2 .);
  rechts : aaa;
  links : aaa;
  z_kette : aaa;
  zk : aaa;
  zeichen : STRING (. 5 .);
  DRUCKER : TEXT;


LABEL
  sprung1;


  FUNCTION Open_out(VAR datei : TEXT;
                    name : t_dat_name) : BOOLEAN;

    (* die funktion liefert die Werte

    true : open erfolgreich
    false: sonst *)

  VAR
    STR_ENDE : INTEGER;
    name_alt : t_dat_name;

  BEGIN

    ASSIGN(datei, name);
    (*$I-*)
    RESET(datei);
    (*$I+*)
    IF IORESULT = 0
    THEN BEGIN
      CLOSE(datei);
      name_alt := name;
      str_ende := POS('.', name);
      IF str_ende <> 0
      THEN
        name := COPY(name, 1, POS('.', name)-1)+'.BAK'
      ELSE
        name := name+'.BAK';
      RENAME(datei, name);
      CLOSE(datei);
      ASSIGN(datei, name_alt);
    END;
    (*$I-*)
    REWRITE(datei);
    (*$I+*)
    open_out := IORESULT = 0;
  END;                        (* ------------------------------------------------------------*)

  PROCEDURE writehex(zahl : INTEGER);

  VAR zeichen : STRING (. 4 .);
    i : INTEGER;
    j : INTEGER;
  CONST
    ch : ARRAY (. 0..15 .) OF CHAR = '0123456789ABCDEF';
  BEGIN
    zeichen := ''; i := 4096;
    REPEAT
      zeichen := zeichen+ch (. zahl DIV i .);
      zahl := zahl MOD i;
      i := i DIV 16;
    UNTIL i = 0;

    WRITE(DRUCKER, zeichen);



  END;
  (*  ENDE WRITEHEX  ************************************************** *)


  PROCEDURE writelnhex(zahl : INTEGER);
  BEGIN
    writehex(zahl);
    WRITELN(DRUCKER);

  END;
  (* ENDE WRITELNHEX ****************************************************)
  PROCEDURE readhex(VAR zahl, f : INTEGER);



  BEGIN
    READLN(datei, zeichen);
    zeichen := ('$'+zeichen);
    VAL(zeichen, zahl, f);
  END;
  (* ENDE READHEX *************************************************************)

  PROCEDURE rechts_links(VAR z_kette, rechts, links : aaa);

  VAR
    bbb : STRING (. 40 .);

  BEGIN
    bbb := z_kette;
    rechts := '';
    links := z_kette;
    z_kette := '';
    IF POS(',', bbb) > 0 THEN
      BEGIN
        rechts := COPY(bbb, POS(',', bbb)+1, 40);
        links := COPY(bbb, 1, POS(',', bbb)-1);
        z_kette := rechts;
      END;

  END;


  PROCEDURE wertlinks(VAR b : INTEGER; VAR z_kette : aaa);

  VAR
    bbb : STRING (. 40 .);
    rechts : STRING (. 40 .);
    links : STRING (. 40 .);
    f : INTEGER;

  BEGIN
    rechts_links(z_kette, rechts, links);
    b := 0;
    VAL(links, b, f);
    IF f <> 0 THEN b := 0;

  END;

  PROCEDURE schreibe(VAR z_kette : aaa);

  VAR
    i : INTEGER;

  BEGIN
    i := 1;

    WHILE i <= LENGTH(z_kette) DO
      BEGIN
        IF COPY(z_kette, i, 1) = '.' THEN WRITE(DRUCKER, ',')
        ELSE WRITE(DRUCKER, COPY(z_kette, i, 1));

        i := i+1;
      END;
  END;
BEGIN
  CLRSCR;
  FOR I := 0to 255 DO
    BEGIN
      opcode (. i .) := '';
    END;
  i := 0;
  WHILE source (. i .) <> '999, ENDE' DO
    BEGIN
      z_kette := source (. i .);
      wertlinks(op, z_kette);
sprung1: rechts_links(z_kette, rechts, links);
      wertlinks(k, z_kette);
      CASE k OF
        0 : opcode (. op .) := source (. i .);
        1 : GOTO sprung1;
        2 : FOR j := 0 TO 7 DO
              BEGIN opcode (. op+j .) := source (. i .) END;
        3 : BEGIN opcode (. op+1 .) := source (. i .); GOTO sprung1; END;
        4 : BEGIN
              IF TRUNC(((op-1)/4+1/256)*4) = (op-1) THEN
                opcode (. op+1 .) := source (. i .)
              ELSE FOR j := 0to 3 DO
                  BEGIN
                  opcode (. op+1 .) := source (. i .); END; GOTO sprung1;
            END;
      END;

      i := i+1
    END;
  (*       clrscr;
  ad_zaehler := 0;
  repeat
  gotoxy(1,1);
  writeln('Bitte Opcode als Hex-Zahl eingeben'); clreol;
  readhex(i,j);
  gotoxy(1,5);
  writehex(ad_zaehler);WRITE(DRUCKER,'      ');
  WRITE(DRUCKER,opcode(.i.));clreol;
  ad_zaehler := ad_zaehler + 1;
  until i >255; *)


  (* Hauptprogramm  *)
  (*  textmode(bw40);  *)
  WRITELN('Bitte den Namen der Objektdatei angeben');
  READLN(name);
  ASSIGN(datei, name);
  RESET(datei);


  (* An dieser Stelle etweder "con" fr Bildschirmausgabe oder "lpt1" fr
  Druckerausgabe einsetzen                                           *)


  ASSIGN(DRUCKER, 'con');
  REWRITE(DRUCKER);
  ad_zaehler := 0;
  WHILE NOT EOF(datei) DO BEGIN
    writehex(ad_zaehler);
    WRITE(DRUCKER, '     ');
    readhex(i, j);
    WRITE(DRUCKER, COPY(zeichen, 2, 4), '    ');
    zk := COPY(opcode (. i .), 5, 20);
    IF zk = '' THEN WRITE(DRUCKER, '???');
    REPEAT rechts_links(zk, rechts, links);
      schreibe(links);
      wertlinks(k, zk);
      CASE k OF
        1 : BEGIN
              readhex(i, j); writehex(i); ad_zaehler := ad_zaehler+1;
            END;
        2 : BEGIN
              j := i-TRUNC(i/8+1/256)*8; WRITE(DRUCKER, j);
            END;
        3 : BEGIN
              j := i-TRUNC(i/8+1/256)*8; WRITE(DRUCKER, j);
            END;
        4 : BEGIN
              j := i-TRUNC(i/2+1/256)*2; WRITE(DRUCKER, j);
            END;

      END;
    UNTIL k = 0;
    WRITELN(DRUCKER);
    ad_zaehler := ad_zaehler+1;
  END;
END.
