(* Programm WDLEPR wandelt eine A-48-Objektdatei in eine Binr-Datei um
die von nahezu allen Eprom-Programmiergerten verwendet werden. Das
Programm ist sehr einfach, es findet keine Typberprfung statt, man
mu also selber auf die Angabe der richtigen Files achten. Wer will,
kann das Programm auf seine eigenen Bedrfnisse zuschneiden.         *)

PROGRAM wdlepr(INPUT, OUTPUT);

VAR
  Daten : BYTE;
  o, f, i : INTEGER;
  wort : BYTE;
  zeile : STRING (. 4 .);
  name : STRING (. 12 .);
  datei : TEXT;
  ausgabe : FILE;
  eprom : ARRAY (. 0..2047 .) OF BYTE;




BEGIN


  WRITELN('Bitte den Namen der Objektdatei angeben');
  READLN(name);
  ASSIGN(datei, name);
  RESET(datei);
  WRITELN('Bitte den Namen der Ausgabedatei angeben');
  READLN(name);
  ASSIGN(ausgabe, name);
  REWRITE(ausgabe);
  i := 0;
  WHILE NOT EOF(datei) DO BEGIN
    READLN(datei, zeile);
    zeile := ('$'+zeile);
    VAL(zeile, o, f);
    eprom (. i .) := o;
    i := i+1;
  END;
  BLOCKWRITE(ausgabe, eprom (. 0 .), 8);
  CLOSE(ausgabe);
  CLOSE(datei);

END.


